#!/usr/bin/env python3
 
from turtle import *
 
# A) výpočet předpisu
pravidla = {
    'F': 'FF',
    'A': 'F[+A]-A',
}
 
řetězec = 'A'
 
for i in range(4):
    nová_generace = ''
    for znak in řetězec:
        nová_generace += pravidla.get(znak, znak)
    print(i, ':', nová_generace)
    řetězec = nová_generace
 
# B) vykreslení obrázku podle získaného předpisu
speed(0)
left(90)
 
zásobník_pozic = []
for znak in řetězec:
    match znak:
        case 'F' | 'A':
            fd(10)
        case '+':
            left(50)
        case '-':
            right(65)
        case '[':
            # ulož aktuální polohu želvy
            zásobník_pozic.append( (position(), heading()) )
        case ']':
            # načti poslední uloženou polohu želvy..
            p, h = zásobník_pozic.pop()
            # ..a nastav podle ní aktuální stav želvy
            up()
            setposition(p)
            setheading(h)
            down()
 
hideturtle()
done()
